<?php
/**
 * @version $Id: competencesControleur.php 41 2009-11-25 11:32:59Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */
   

// Controleur des competences

class competencesControleur extends applicationControleur{

  protected $_aideMessage = '<p>Les comp&eacute;tences sont divis&eacute;es en trois groupes d\'appartenance : le socle commun, les communes et les personnelles.
                            Il est &eacute;galement possible de d&eacute;composer une comp&eacute;tence du socle en plusieurs comp&eacute;tences de niveau 2</p>
                            <p><span class="red">Attention</span> : Les comp&eacute;tences communes doivent &ecirc;tre rattach&eacute;es &agrave; un ou plusieurs professeurs !</p>';

  /**
   * On envoie la liste des comptences du socle commun et la vue affichera les dpendances en fonction des droits
   */
  public function index(){

    $this->_titre = 'Les comp&eacute;tences';
    $this->_aideMessage .= '<p>Cette premi&egrave;re page pr&eacute;sente les comp&eacute;tences du socle de tous les domaines sans tenir compte de vos pr&eacute;f&eacute;rences.</p>';

    # Tableau des comptences caches par l'admin
    $cachees    = JCompetenceVisiblePeer::socleCacheRne($this->user->getRne());

    $c = new Criteria();
    $c->addAscendingOrderByColumn(CompetenceGrpPeer::ORDRE);
    //$c->addAscendingOrderByColumn(CompetencePeer::NOMCOURT);
    $c->add(CompetencePeer::NIVEAU, 2, Criteria::NOT_EQUAL);
    $c->add(CompetencePeer::RNE, array('all', $this->user->getRne()), Criteria::IN);
    $c->add(CompetencePeer::COMPETENCE_ID, $cachees, Criteria::NOT_IN);
    if (isset($_SESSION['voirsesdomaines']) AND $_SESSION['voirsesdomaines'] == 'o'){
      $c->add(CompetencePeer::CPTCEGRP_ID, $this->user->getDomainesDeCetUtilisateur(), Criteria::IN);
    }
    $c->add(CompetencePeer::TYPE, 'socle', Criteria::EQUAL);
    $this->_arrayTexte = CompetencePeer::doSelectJoinAll($c);

  }

  public function ajouter(){

    if ($this->_requete->isPost() === true){

      # On commence par chercher l'ordre de la comptence gnrale  la quelle se rattache cette comptence
      if ($this->_requete->ajoutercptce['cptcegrp'] == '0'){
        $this->setErreurMessage('Il faut absolument rattacher votre comp&eacute;tence  une comp&eacute;tence du socle commun !');
        $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
        exit();
      }else{
        # on vrifie que cette comptence du socle existe vraiment
        $testsocle = CompetencePeer::retrieveByPK($this->_requete->ajoutercptce['cptcegrp']);
        if (!empty ($testsocle)){
          $cptcegrp = $testsocle->getCptcegrpId();
        }else{
          $this->setErreurMessage('Il ne faut pas modifier les donn&eacute;es envoy&eacute;es par le navigateur &agrave la main !');
          $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
          exit();
        }
      }

      # On vrifie que cette comptence possde un nomcourt non nul
      if ($this->_requete->ajoutercptce['nomcourt'] == ''){
        $this->setErreurMessage('Il faut donner un nom court &agrave; votre comp&eacute;tence !');
        $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
        exit();
      }

      # On cre une instance de la comptence
      $newCptce = new Competence();
      $newCptce->setNomcourt(htmlentities($this->_requete->ajoutercptce['nomcourt']));
      # Si le nom long est vide, alors il est gal au nom court
      $nomlong = $this->_requete->ajoutercptce['nomlong'] == '' ? $this->_requete->ajoutercptce['nomcourt'] : $this->_requete->ajoutercptce['nomlong'];
      $newCptce->setNomlong(htmlentities($nomlong));
      $newCptce->setCompetenceId($this->_requete->ajoutercptce['cptcegrp']);
      # Le niveau de la comptence est de 3 par dfaut (perso / pda)
      $newCptce->setNiveau(3);
      # On vrifie si cet utilisateur a le droit suffisant pour enregistrer une comptence de ce type
      if ($this->user->getRole() == 'superadmin' OR $this->verifDroitsSansVirer('ajoutersocle') === true){
        $newCptce->setType($this->_requete->ajoutercptce['type']);
        # On regarde si c'est demand niveau 2 ?
        if ($this->_requete->ajoutercptce['niveau'] == 2){
          $newCptce->setNiveau(2);
        }
      # les cptces communes  l'quipe dites "peda"
      }elseif($this->verifDroitsSansVirer('ajouterpeda') === true AND $this->_requete->ajoutercptce['type'] == 'peda'){
        $newCptce->setType('peda'); // Voir plus bas comment ajouter les professeurs de cette comptence pdagogique
      }elseif($this->_requete->ajoutercptce['type'] == 'perso'){
        $newCptce->setType('perso');
      }else{
        $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      }

      if ($this->_requete->ajoutercptce['type'] == 'perso'){
        $newCptce->setUtilisateur($this->user);
      }
      $newCptce->setCptcegrpId($cptcegrp);
      # Sans oublier le Rne
      if ($newCptce->getType() == 'socle'){
        $newCptce->setRne('all');
      }else{
        $newCptce->setRne($this->user->getRne());
      }

      if ($newCptce->save()){
        if ($newCptce->getType() == 'peda'){
          # Il faut maintenant s'occuper de voir  quels professeurs ces comptences sont-elles rattaches
          if (count($this->_requete->ajoutercptce['pedaprofesseurs']) < 1){
            $this->setErreurMessage('Dans le cas d\'une comp&eacute;tence commune &agrave; l`&eacute;quipe, il faut la rattacher &agrave; une liste de professeurs !');
            $this->redirect_to(array('action'=>'index', 'info'=>$this->user->getLogin()));
            exit();
          }else{
            foreach ($this->_requete->ajoutercptce['pedaprofesseurs'] as $profs) {
              $newjoin = new JCompetencesProfesseurs();
              $newjoin->setCompetenceId($newCptce->getId());
              $newjoin->setProfesseurId($profs);
              $newjoin->save();
            }
          }
        }
        $this->redirect_to(array('action'=>'index', 'info'=>'enregistre'));
        exit();
      }else{
        $this->setErreurMessage('Impossible d`enregistrer cette comp&eacute;tence !');
        $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
        exit();
      }
    }

  }

  public function effacer(){

    if ($this->_requete->isGet() === true){

      # Premier cas : les comptences personnelles
      if ($this->_params['info'] == 'perso'){

        $c = new Criteria();
        $c->add(CompetencePeer::TYPE, 'perso', Criteria::EQUAL);
        $c->add(CompetencePeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
        $c->add(CompetencePeer::ID, $this->_requete->getGet('cptce'));
        $test = CompetencePeer::doSelect($c);

        if (empty ($test)){
          $this->setErreurMessage('Impossible de supprimer cette comp&eacute;tence car elle semble ne pas exister ou alors vous n\'avez pas les droits suffisants pour le faire.');
          $this->redirect_to(array('action'=>'perso', 'info'=>$this->user->GetLogin()));
          exit();
        }else{
          # On vrifie qu'elle n'est pas utilise dans une grille
          $c = new Criteria();
          $c->add(JGrilleCompetencePeer::COMPETENCE_ID, $test[0]->getId());
          $c->setLimit(1);
          $verif = JGrilleCompetencePeer::doSelect($c);
          if (! empty ($verif)){
            $this->setErreurMessage('Cette comp&eacute;tence est utilis&eacute;e dans au moins une grille, vous ne pouvez pas la d&eacute;truire !');
            $this->redirect_to(array('action'=>'perso', 'info'=>$this->user->GetLogin()));
            exit();
          }

          $test[0]->delete();
          $this->redirect_to(array('action'=>'perso', 'info'=>$this->user->GetLogin()));
          exit();
        }

      # Deuxime cas : les comptnces communes dites pdagogiques
      }elseif($this->_params['info'] == 'commun'){
        # les droits
        if ($this->user->getRole() != 'superadmin'){
          if ($this->verifDroitsSansVirer('effacercommun') === false){
            # On jecte
            $this->dehorsUtilisateur('', __CLASS__, 'effacercommun', $this->user->getId());
          }
        }
        # On efface enfin sans oublier de dlier les utilisateurs de cette comptence
        $c = new Criteria();
        $c->add(CompetencePeer::TYPE, 'peda', Criteria::EQUAL);
        $c->add(CompetencePeer::RNE, $this->user->getRne());
        $c->add(CompetencePeer::ID, $this->_requete->getGet('cptce'));
        $test = CompetencePeer::doSelect($c);

        if (empty ($test)){
          $this->setErreurMessage('Impossible de supprimer cette comp&eacute;tence car elle semble ne pas exister ou alors vous n\'avez pas les droits suffisants pour le faire.');
          $this->redirect_to(array('action'=>'commun', 'info'=>'pedagogique'));
          exit();
        }else{
          # On vrifie qu'elle n'est pas utilise dans une grille
          $c = new Criteria();
          $c->add(JGrilleCompetencePeer::COMPETENCE_ID, $test[0]->getId());
          $c->setLimit(1);
          $verif = JGrilleCompetencePeer::doSelect($c);
          if (! empty ($verif)){
            $this->setErreurMessage('Cette comp&eacute;tence est utilis&eacute;e dans au moins une grille, vous ne pouvez pas la d&eacute;truire !');
            $this->redirect_to(array('action'=>'perso', 'info'=>$this->user->GetLogin()));
            exit();
          }
          $_id_del = $test[0]->getId(); // marqueur pour effacer ensuite tous les liens cptce-prof
          $test[0]->delete();
          $c = new Criteria();
          $c->add(JCompetencesProfesseursPeer::COMPETENCE_ID, $_id_del);
          $effacer = JCompetencesProfesseursPeer::doDelete($c);
          $this->redirect_to(array('action'=>'commun', 'info'=>'pedagogique'));
          exit();
        }

      }

    }

  }

  public function modifier(){

    if ($this->_params['info'] != '' AND $this->_requete->isPost() === false){

      # On vrifie que la comptence est bien  cet utilisateur
      $c = new Criteria();
      if ($this->verifDroitsSansVirer('effacercommun') !== true){
        # On limite alors aux seules comptences personnelles
        $c->add(CompetencePeer::TYPE, 'perso', Criteria::EQUAL);
        $c->add(CompetencePeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
      }
      $c->add(CompetencePeer::ID, $this->_params['info']);
      $c->add(CompetencePeer::RNE, $this->user->getRne());
      $test = CompetencePeer::doSelect($c);

      if (empty ($test)){
        $this->setErreurMessage('Cette comp&eacute;tence n\'existe pas ou n\'est pas &agrave; vous !');
        logControleur::insertLog('pirate', 1, 'Tente de modifier une comptence perso sans en tre le propritaire.', $this->user->getId());
        $this->redirect_to(array('action'=>'perso', 'info'=>'pirate'));
        exit();
      }else{

        if ($test[0]->getType() == 'peda'){
          # On vrifie que cet utilisateur peut la modifier
          if ($this->verifDroitsSansVirer('effacercommun') !== true){
            $this->setErreurMessage('Cette comp&eacute;tence n\'est pas &agrave; vous !');
            logControleur::insertLog('pirate', 1, 'Tente de modifier une comptence peda sans en avoir le droit.', $this->user->getId());
            $this->redirect_to(array('action'=>'perso', 'info'=>'pirate'));
            exit();
          }

        }elseif($test[0]->getType() == 'perso'){
          if ($test[0]->getUtilisateurId() != $this->user->getId()){
            $this->setErreurMessage('Cette comp&eacute;tence n\'est pas &agrave; vous !');
            logControleur::insertLog('pirate', 1, 'Tente de modifier une comptence perso sans en tre le propritaire2.', $this->user->getId());
            $this->redirect_to(array('action'=>'perso', 'info'=>'pirate'));
            exit();
          }
        }

        # On peut alors envoyer un formulaire de modification
        $form = new formulaireHtml(array('name'=>'modifierCptce', 'info'=>'mod', 'forme'=>'p'), $this->_params);
        $form->addInput(array('name'=>'nomcourt', 'value'=>$test[0]->getNomcourt(), 'size'=>80, 'label'=>'Nom court : '));
        $texte_title = 'L\'affichage des comp&eacute;tences est ordonn&eacute; sur le nom long, vous pouvez ajouter une lettre au d&eacute;but pour assurer un affichage coh&eacute;rent !';
        $form->addInput(array('name'=>'nomlong', 'value'=>$test[0]->getNomlong(), 'size'=>80, 'label'=>'Nom long : ', 'title'=>$texte_title));
        $form->addInput(array('type'=>'hidden', 'name'=>'cptceID', 'value'=>$test[0]->getId()));
        $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

        $this->form = $form;

      }

    }elseif($this->_requete->isPost() === true){

      # On enregistre les modifications demandes
      $cptce = CompetencePeer::retrieveByPK($this->_requete->modifierCptce['cptceID']);
      $cptce->setNomcourt($this->_requete->modifierCptce['nomcourt']);
      $cptce->setNomlong($this->_requete->modifierCptce['nomlong']);
      if ($cptce->save()){
        if ($cptce->getType() == 'peda'){
          $this->redirect_to(array('action'=>'commun', 'info'=>'pedagogique'));
        }else{
          $this->redirect_to(array('action'=>'perso', 'info'=>'modifie'));
        }
        exit();
      }else{
        $this->setErreurMessage('Impossible de modifier cette comp&eacute;tence');
        $this->redirect_to(array('action'=>'perso', 'info'=>'erreur'));
        exit();
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  }

  public function commun(){

    $this->_titre = 'Les comp&eacute;tences';

    $this->_texte = $this->_params['info'];

    $cr = new Criteria();
    if ($this->_params['info'] == 'pedagogique'){
      # On cherche les peda de cet utilisateur
      $peda_a_afficher = JCompetencesProfesseursPeer::listeCptcesCommunesCetUtilisateur($this->user);
      $cr->add(CompetencePeer::ID, $peda_a_afficher, Criteria::IN);
      $this->_aideMessage .= '<p>Les comp&eacute;tences commune (ou "p&eacute;dagogiques") peuvent &ecirc;tre saisies par le superadmin ou par un professeur coordinateur !</p>';
    }elseif($this->_params['info'] == 'socleCommun'){
      $cr->add(CompetencePeer::TYPE, 'socle', Criteria::EQUAL);
      $this->_aideMessage .= '<p>Les comp&eacute;tences du socle commun sont la base de rattachement de toutes les autres comp&eacute;tences !</p>';
    }
    $cr->addAscendingOrderByColumn(CompetenceGrpPeer::ORDRE);
    //$cr->addAscendingOrderByColumn(CompetencePeer::NOMCOURT);
    # On teste les prfrences de cet utilisateur
    $test = $this->user->getDomainesDeCetUtilisateur();
    if (empty ($test)){
      $this->_arrayTexte = CompetencePeer::doSelectJoinCompetenceGrp($cr);
    }else{
      $liste = CompetencePeer::doSelectJoinCompetenceGrp($cr);
      # On tient compte des prfrences de cet utilisateur
      foreach ($liste as $cptce) {
        if (in_array($cptce->getCptcegrpId(), $this->user->getDomainesDeCetUtilisateur())){
          $this->_arrayTexte[] = $cptce;
        }
      }
    }

  }

  public function perso(){
    $this->_vue = 'commun';

    $this->_aideMessage .= 'Vous ne pouvez effacer que les comp&eacute;tences que vous avez cr&eacute;&eacute;es.';
    $this->_aideMessage .= '<p>La liste de vos comp&eacute;tences personnelles n\'est visible que de vous.</p>';

    $cr = new Criteria();
    $cr->add(CompetencePeer::TYPE, 'perso', Criteria::EQUAL);
    $cr->add(CompetencePeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
    $cr->addAscendingOrderByColumn(CompetenceGrpPeer::ORDRE);
    //$cr->addAscendingOrderByColumn(CompetencePeer::NOMCOURT);

    $this->_arrayTexte = CompetencePeer::doSelectJoinCompetenceGrp($cr);


  }

  /**
   * Renvoie la liste des domaines du socle commun
   */
  public function domaines(){

    if ($this->_params['info'] == 'inverser'){
      $_SESSION['voirsesdomaines'] = (isset($_SESSION['voirsesdomaines']) AND $_SESSION['voirsesdomaines'] == 'o') ? $_SESSION['voirsesdomaines'] = 'n' : $_SESSION['voirsesdomaines'] = 'o';
      $this->redirect_to(array('action'=>'index', 'info'=>'modifie'));
      exit();
    }

    $this->_titre = 'Les domaines de comp&eacute;tences';

    $this->_aideMessage = 'Vous pouvez limiter l\'affichage des seuls domaines vous concernant dans toute l\'application en les s&eacute;lectionnant ici.';

    $cr = new Criteria();
    $cr->addAscendingOrderByColumn(CompetenceGrpPeer::ORDRE);
    $this->_arrayTexte = CompetenceGrpPeer::doSelect($cr);

    $c = new Criteria();
    $c->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
    $c->addAscendingOrderByColumn(JCompetencegrpUtilisateurPeer::CPTCEGRP_ID);
    $mesprefs = JCompetencegrpUtilisateurPeer::doSelect($c);

    if (count($mesprefs) >= 1){
      $this->_texte = '<h5 class="margin10">Mes pr&eacute;f&eacute;rences</h5>'."\n";
      $this->_texte .= '<div class="div2 moz margin5" style="width:40%;">';
    }
    foreach ($mesprefs as $mapref){
      $options = array(
                      'action'=>'effacerDomaine',
                      'info'=>$mapref->getCompetenceGrp()->getId(),
                      'js'=>'onclick="return confirmlink(this, \'ID = '.$mapref->getCompetenceGrp()->getId().'\', \'&Ecirc;tes-vous certain de vouloir effacer cette pr&eacute;f&eacute;rence ?\');"',
                      'intitule'=>'<img src="'.$this->_params['path'].'/www/images/delete16.png" alt="Suppr." title="Supprimer" />'
                      );
      $this->_texte .= '<p>'.$mapref->getCompetenceGrp()->getOrdre().' '.$mapref->getCompetenceGrp()->getNom().' ('.$this->tag_a($options).')</p>'."\n";
    }
    if (count($mesprefs) >= 1){
      $this->_texte .= '</div>';
    }

  }

  public function ajaxPreferences(){
    echo '<h5>Mes pr&eacute;f&eacute;rences</h5>';

    if ($this->_requete->isPost() === true){

      $c = new Criteria();
      $c->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
      $c->add(JCompetencegrpUtilisateurPeer::CPTCEGRP_ID, substr($this->_requete->_id, -1), Criteria::EQUAL);
      $mesprefs = JCompetencegrpUtilisateurPeer::doSelect($c);

      if (empty($mesprefs)){
        $addPreference = new JCompetencegrpUtilisateur();
        $addPreference->setUtilisateur($this->user);
        $addPreference->setCptcegrpId(substr($this->_requete->_id, -1));
        if ($addPreference->save()){
          // rien
        }else{
          echo '<p class="red">Impossible d\enregistrer cette pr&eacute;f&eacute;rence !</p>';
        }
      }else{
        $delpreference = JCompetencegrpUtilisateurPeer::doDelete($mesprefs[0]);
      }

    }

    $c = new Criteria();
    $c->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
    $c->addAscendingOrderByColumn(JCompetencegrpUtilisateurPeer::CPTCEGRP_ID);
    $mesprefs = JCompetencegrpUtilisateurPeer::doSelect($c);

    echo '<div class="div2 moz margin5" style="width:40%;">';
    foreach ($mesprefs as $mapref){
      $options = array(
                      'action'=>'effacerDomaine',
                      'info'=>$mapref->getCompetenceGrp()->getId(),
                      'js'=>'onclick="return confirmlink(this, \'ID = '.$mapref->getCompetenceGrp()->getId().'\', \'&Ecirc;tes-vous certain de vouloir effacer cette pr&eacute;f&eacute;rence ?\');"',
                      'intitule'=>'<img src="'.$this->_params['path'].'/www/images/delete16.png" alt="Suppr." title="Supprimer" />'
                      );
                      echo '<p>'.$mapref->getCompetenceGrp()->getOrdre().' '.$mapref->getCompetenceGrp()->getNom().' ('.$this->tag_a($options).')</p>';
    }
    echo '</div>';

    exit();// pour de l'ajax
  }

  public function effacerDomaine(){
    if ($this->_params['info'] != ''){
      $c = new Criteria();
      $c->add(JCompetencegrpUtilisateurPeer::UTILISATEUR_ID, $this->user->getId(), Criteria::EQUAL);
      $c->add(JCompetencegrpUtilisateurPeer::CPTCEGRP_ID, $this->_params['info'], Criteria::EQUAL);
      $test = JCompetencegrpUtilisateurPeer::doSelect($c);

      if (!empty ($test)){
        $test[0]->delete();
        $this->redirect_to(array('action'=>'domaines', 'info'=>'tous'));
        exit();
      }else{
        $this->setErreurMessage('Ce domaine n\'existe pas !');
        logControleur::insertLog('pirate', 1, 'Tentative de suppression d\'une pr&eacute;f&eacute;rence qui n\'existe pas '.$this->_params['info'], $this->user->getId());
        $this->redirect_to(array('action'=>'domaines', 'info'=>'erreur'));
        exit();
      }

    }
  }

  /**
   * Renvoie le sous menu des comptences
   *
   * @return string le menu
   */
  protected function getMenu(){

    # Les droits sur le type de comptences que l'utilisateur peut crer
    $tab_droits_type_cpteces = array('perso'=>'Personnelle');
    if ($this->verifDroitsSansVirer('ajoutersocle')){
      $tab_droits_type_cpteces['socle'] = 'Socle commun';
    }
    if ($this->verifDroitsSansVirer('ajouterpeda')){
      $tab_droits_type_cpteces['peda'] = 'Commune  l\'&eacute;quipe';
    }

    $formulaire = new formulaireHtml(array('name'=>'ajoutercptce', 'action'=>'ajouter', 'forme'=>'p'), $this->_params);
    $formulaire->addSelect(array('name'=>'cptcegrp',
                                 'label'=>'Rattach&eacute;e  : <a href="../index/login?voir=niveau2">[Niveau 2 seulement]</a> ',
                                 'title'=>'Il est indispensable de rattacher votre comptence au socle commun',
                                 'limite'=>150),
                           CompetencePeer::listeCptecesAvecPreferenceForSelect('socle', $this->user));
    $formulaire->addInput(array('name'=>'nomcourt', 'label'=>'Nom court : ', 'size'=>'40'));
    $formulaire->addInput(array('name'=>'nomlong', 'label'=>'Nom long : ', 'size'=>'40'));
    $formulaire->addSelect(array('name'=>'type', 'label'=>'Type : '), $tab_droits_type_cpteces);
    if ($this->verifDroitsSansVirer('ajouterNiveau2')){
      $formulaire->addSelect(array('name'=>'niveau',
                                   'label'=>'Niveau',
                                   'title'=>'Attention : socle niveau 2 veut dire que cette comp&eacute;tence d&eacute;compose une comp&eacute;tence du socle'),
                             array('3'=>'Pas de niveau' ,'2'=>'Socle Niveau 2'));
    }
    if ($this->verifDroitsSansVirer('ajouterpeda')){
      $formulaire->addSelect(array('name'=>'pedaprofesseurs',
                                           'label'=>'Pour quels professeurs ?',
                                           'title'=>'Uniquement pour les comp&eacute;tences communes',
                                           'multiple'=>'on'),
                              UtilisateurPeer::listeProfesseursForSelect());
    }
    $formulaire->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    # On analyse si cet utilisateur ne veut afficher que ses domaines
    if (isset($_SESSION['voirsesdomaines']) AND $_SESSION['voirsesdomaines'] == 'o'){
      $aff_domaines = 'Voir tous les domaines';
    }else{
      $aff_domaines = 'Ne voir que ses domaines';
    }

    # On vrifie si cet utilisateur veut ajouter une comptence en ne voyant que ses comptences de niveau 2
    $aff_display = (isset($_GET['voir']) AND $_GET['voir'] == 'niveau2') ? '' : 'display:none;';

    # Comme on ajoute des domaines de comptences dans ses prfrences avec AJAX, on enlve la possibilit de crer
    # de nouvelles comptences quand l'action demande est "domaines"
    $addCptces = ($this->_params['action'] == 'domaines') ? 
                ' <span title="Vous devez sortir des domaines pour ajouter une comp&eacute;tence">Ajouter une comp&eacute;tence</span> - ' :
                '<span title="Cliquez pour ajouter une comp&eacute;tence" class="lien" onclick="inverserDiv(\'addCompetenceId\');">
                  <img src="'.$this->_params['path'].'/www/images/ajouter.png" />Ajouter une comp&eacute;tence
                </span> - ';

    return '
    <p>
      '.$addCptces.'
      '.$this->tag_a(array('intitule'=>'Socle commun', 'action'=>'commun', 'info'=>'socleCommun', 'title'=>'Voir les comp&eacute;tences du socle commun')).' -
      '.$this->tag_a(array('intitule'=>'Les domaines', 'action'=>'domaines', 'info'=>'tous', 'title'=>'Voir la liste des domaines du socle commun')).' -
      '.$this->tag_a(array('intitule'=>'P&eacute;dagogique', 'action'=>'commun', 'info'=>'pedagogique', 'title'=>'Voir les comp&eacute;tences communes')).' -
      '.$this->tag_a(array('intitule'=>'Personnelles', 'action'=>'perso', 'info'=>$this->user->getLogin(), 'title'=>'Voir vos comp&eacute;tences personnelles')).' -
      '.$this->tag_a(array('intitule'=>$aff_domaines, 'action'=>'domaines', 'info'=>'inverser', 'title'=>'Voir uniquement les comp&eacute;tences de ses domaines')).' - 
    </p>
  <div id="addCompetenceId" class="div2 moz" style="'.$aff_display.'width:80%;">
    '.$formulaire->returnForm().'
  </div>
    ';
  }

} 
?>