<?php
/**
 * @version $Id: controlesControleur.php 40 2009-11-24 20:59:32Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */
   

// Controleur des controles

class controlesControleur extends applicationControleur{

  /**
   * tableau des couleurs de validation
   *
   * @var array $tab[lettre] = hxadcimal
   */
  protected $_couleurs = array();

  public function index(){

  }

  public function perso(){
    $this->_titre = 'Mes contr&ocirc;les';
    $this->_title .= ' : &eacute;valuer';

    $this->_aideMessage = '<p>Vous avez sous les yeux la liste de vos grilles de comp&eacute;tences. Assurez vous que chaque grille comporte bien
    une liste de comp&eacute;tences &agrave; &eacute;valuer ainsi qu\'un ou plusieurs groupe(s) d\'&eacute;l&egrave;ves.
    Un contr&ocirc;le est donc un ensemble de comp&eacute;tences &eacute;valu&eacute;es pour un groupe d\'&eacute;l&egrave;ves.</p>
    <p class="green">[<span class="blue">Evaluer</span>] permet de lancer une &eacute;valuation sur un groupe.</p>
    <p class="green">[<span class="blue">Cacher</span>] permet de cacher/montrer la liste des contr&ocirc;les d&eacute;j&agrave; effectu&eacute;s.</p>
    <p>Pour voir l\'intitul&eacute; de vos comp&eacute;tences lors de la saisie des &eacute;valuations, cliquer sur 
    [<span class="blue">voir les comp&eacute;tences</span>] ou survolez les [C1] [C2] ... le cadre des comp&eacute;tences peut tre dplacer.</p>
    <p class="red">Vous ne devez utiliser que les lettres qui sont inscrites en haut de la page quand vous cr&eacute;ez un nouveau contr&ocirc;le !</p>
    <p>Vous pouvez vous d&eacute;placer avec les fl&egrave;ches dans le tableau des r&eacute;sultats.</p>';

    if ($this->_params['info'] == 'toutes'){
      $peda = true;
    }else{
      $peda = false;
    }

    $this->_arrayTexte = GrillePeer::listeGrillesJoinGroupesCetUtilisateur($this->user, $peda);


  } // perso

  /**
   * Permet d'effacer un contrle
   */
  public function effacer(){

    if ($this->_params['info'] != ''){

      # On vrifie le propritaire de ce controle et si c'est bon, on efface (la demande de confirmation est en javascript
      $c = new Criteria();
      $c->add(ControlePeer::RNE, $this->user->getRne());
      $c->add(ControlePeer::ID, $this->_params['info'], Criteria::EQUAL);
      $test = ControlePeer::doSelect($c);
      if (empty ($test)){
        $this->setErreurMessage('Ce contr&ocirc;le n\'existe pas !');
        logControleur::insertLog('pirate', 1, 'Tente de supprimer un controle inexistant', $this->user->getId());
        $this->redirect_to(array('action'=>'perso', 'info'=>'erreur'));
        exit();
      }elseif(count($test) == 1){

        # On vrifie qu'il n'y a qu'un propritaire et que c'est le bon
        $test2 = $test[0]->getJControlePossesseurs();
        if (count($test2) >= 2){
          $this->setErreurMessage('Impossible d\'effacer ce contr&ocirc;le car il appartient &agrave; plusieurs utilisateurs ! Veuillez en faire la demande au superAdmin');
          $this->redirect_to(array('action'=>'perso', 'info'=>'stop'));
        }elseif ($test2[0]->getUtilisateurId() == $this->user->getId()){
          # On peut effacer le tout (le controle et ses rsultats)

            //-> les rsultats d'abord
          $cr = new Criteria();
          $cr->add(JControleResultatPeer::CONTROLE_ID, $test[0]->getId(), Criteria::EQUAL);
          $_resultcontrol = JControleResultatPeer::doDelete($cr);
            //-> le possesseur ensuite
          $cr = new Criteria();
          $cr->add(JControlePossesseurPeer::CONTROLE_ID, $test[0]->getId(), Criteria::EQUAL);
          $_possesseurcontrol = JControlePossesseurPeer::doDelete($cr);
            //-> et enfin le controle
          $test[0]->delete();
          $this->redirect_to(array('action'=>'perso', 'info'=>'efface'));
          exit();
        }

      }else{
        logControleur::insertLog('pirate', 1, 'Une tentative de suppression renvoie plusieurs controles : '.__CLASS__.' - '.__METHOD__.' - ligne '.__LINE__, $this->user->getId());
        $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
        exit();
      }


    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      exit();
    }

  } // effacer()

  /**
   * AJAX pour l'valuation des lves, renvoie du html avec un tableau eleves-competences
   */
  public function ajaxEvaluer(){

    if ($this->_requete->isPost() === true AND $this->_requete->type == 'evaluer'){
      # On vrifie la validit des informations reues
      $test1 = explode("|", $this->_requete->_id);

      if (count($test1) != 3 OR $test1[0] != 'evaluer'){
        echo 'Les donn&eacute;es sont corrompues, impossible d\'afficher ce que vous demandez !';
        logControleur::insertLog('ajax', '1', 'Donnes ajax fausses ($test1) : '.$this->_requete->_id . 'C::'.__CLASS__.'-A::'.__METHOD__, $this->user->getId());
        exit();
      }

      # On vrifie que cet utilisateur possde bien une entre correspondante
      $test2 = GrillePeer::utilisateurUtiliseCetteGrilleEtCeGroupe($this->user, $test1[1], $test1[2]);
      if ($test2 !== false){

        $contenu_div_cptces = NULL; // le contenu du div qui propose l'intitul des comptences
        // On renvoie du html en tableau
        $formulaire = new formulaireHtml(array('name'=>'controle', 'forme'=>'td', 'action'=>'ajouterResultatControle'), $this->_params);
        $formulaire->openFieldset(array('class'=>'margin10 fieldset'));
        $formulaire->addInput(array('name'=>'nom', 'label'=>'Nom du contr&ocirc;le : '));
        $formulaire->addInput(array('name'=>'date', 'label'=>'Date du contr&ocirc;le : '.date('d').'/'.date('m').'/'.date('Y'), 'title'=>'Respectez le format de la date jj/mm/yyyy'));
        $formulaire->closeFieldset();
        $formulaire->addInput(array('type'=>'hidden', 'name'=>'grilleId', 'value'=>$test2->getGrille()->getId()));
        $formulaire->addInput(array('type'=>'hidden', 'name'=>'groupeId', 'value'=>$test2->getGroupe()->getId()));
        $formulaire->addLegende('<table class="table"><tbody><tr><th>Eleves</th>'."\n");
        $iter = 1;
        $criter1 = new Criteria();
        $criter1->addAscendingOrderByColumn(CompetencePeer::NOMLONG);
        $criter1->addAscendingOrderByColumn(JGrilleCompetencePeer::COMPETENCE_ID);

        foreach ($test2->getGrille()->getJGrilleCompetencesJoinCompetence($criter1) as $cptce) {
          $contenu_div_cptces .= 'C '.$iter.' : '.($cptce->getCompetence()->getNomlong()).'<br />';
          $formulaire->addLegende('<th class="textcenter" title="'.html_entity_decode(utf8_encode($cptce->getCompetence()->getNomlong())).'">C '.$iter.'</th>');
          ++$iter;
        }
        $formulaire->addLegende('</tr></tbody>'."\n");
        $_class = 'lig1';
        $criter2 = new Criteria();
        $criter2->addAscendingOrderByColumn(UtilisateurPeer::NOM);
        $criter2->addAscendingOrderByColumn(UtilisateurPeer::PRENOM);
        $ligne = 1;
        foreach ($test2->getGroupe()->getJGroupeElevesJoinUtilisateur($criter2) as $eleve) {

          $formulaire->addTag('tr', array('class'=>$_class));
          $formulaire->addTag('td');
          $formulaire->addLegende($eleve->getUtilisateur()->getNom() . ' ' . htmlentities($eleve->getUtilisateur()->getPrenom()));
          $formulaire->addTag('/td');
          $col = 1;
          foreach ($test2->getGrille()->getJGrilleCompetencesJoinCompetence($criter1) as $cptce) {
            $formulaire->addInput(array(
                                    'name'=>'resultat|'.$eleve->getUtilisateur()->getId().'|'.$cptce->getCompetence()->getId(),
                                    'value'=>'',
                                    'style'=>'background-color: white;display: inline;',
                                    'title'=>$cptce->getCompetence()->getNomcourt(),
                                    'id'=> $ligne.'-'.$col /*'idResult|'.$eleve->getUtilisateur()->getId().'|'.$cptce->getCompetence()->getId()*/,
                                    'size'=>'5'));
            ++$col;
          }
          $formulaire->addTag('/tr');

          if ($_class == 'lig1'){
            $_class = 'lig2';
          }else{
            $_class = 'lig1';
          }
          ++$ligne;
        }

      }else{
        echo 'Les donn&eacute;es sont fausses, impossible d\'afficher ce que vous demandez !';
        logControleur::insertLog('pirate', '1', 'Utilisateur tente sur Grille/groupe pas  lui ($test2) : '.$this->_requete->_id . 'C::'.__CLASS__.'-A::'.__METHOD__, $this->user->getId());
        exit();
      }

    }
    $formulaire->addInput(array('type'=>'submit', 'value'=>'Enregistrer', 'name'=>'enregistrer'));
    $formulaire->addLegende('</table>');
    echo '<span class="lien" title="Vous pouvez d&eacute;placer cette liste pour la faire suivre" onclick="inverserDiv(\'idDivListeCptces\');onDrag(\'idDivListeCptces\');">Voir les comp&eacute;tences</span>';
    echo '<div id="idDivListeCptces" class="fixe moz black div transparence" style="display:none;width:50%;">'.$contenu_div_cptces.'</div>';
    echo $formulaire->returnForm();

    exit(); // ajax
  } // ajaxEvaluer()

  /**
   * Permet de changer le nom et la date du contrle aprs l'avoir enregistrer
   */
  public function changerNomControle(){

    if ($this->_requete->isPost() === true){
      $controle = ControlePeer::retrieveByPK($this->_requete->controle_id);
      $auth = false;
      foreach ($controle->getJControlePossesseurs() as $JCP) {
        if ($JCP->getUtilisateurId() == $this->user->getId()){
          # C'est bien un contrle  cet utilisateur
          $auth = true;
        }
      }
      if ($auth === false){
        $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      }
      $controle->setNomcourt(htmlentities($this->_requete->controle_nom));
      $controle->setNomlong(htmlentities($this->_requete->controle_nom));
      $test = explode("/", $this->_requete->date_controle);
      if(count($test) == 3){
        $controle->setCreatedOn(mktime(2, 0, 0, $test[1], $test[0], $test[2]));
      }

      if ($controle->save()){
        $this->setMessage('Modification enregistr&eacute;e !');
      }else{
        $this->setErreurMessage('Impossible de modifier le nom de ce contr&ocirc;le !');
      }

      $this->redirect_to(array('action'=>'controle', 'info'=>$controle->getId()));
      exit();

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  } // ajaxChangerNomControle()

  /**
   * Enregistrer les controles
   * 
   */
  public function ajouterResultatControle(){

    $this->_vue = 'perso';

    if ($this->_requete->isPost() === true AND is_array($this->_requete->controle) === true){

      $marqueur = true;

      foreach ($this->_requete->controle as $cle => $valeur) {
        //echo '<br />Cle = ' . $cle . ' et sa valeur = ' . $valeur;
        $test = explode('|', $cle); // $cle est sous la forme resultat|:utilisateurId|:CompetenceId

        if (count($test) == 3 OR in_array($test[0], array('nom', 'date', 'grilleId', 'groupeId', 'enregistrer')) === true){

          # INUTILE :  Il faut vrifier que l'utilisateur possde cet lve dans un groupe et cette comptence
          if ($test[0] == 'resultat'){

            $new_resultat = new JControleResultat();
            $new_resultat->setControleId($new_controle->getId());
            $new_resultat->setCompetenceId($test[2]);
            $new_resultat->setUtilisateurId($test[1]);
            # on ne garde que la dernire lettre car elle correspond  la bonne couleur affiche  l'cran
            $resultat = mb_strlen($valeur) >= 2 ? substr($valeur, -1, 1) : $valeur;
            # La valeur de l'valuation est nulle si la lettre ne correspond pas  un niveau de validation permis
            if (!array_key_exists($resultat, ValidationNiveauPeer::listeNiveauxValidation())){
              $resultat = '';
            }
            $new_resultat->setResultat($resultat);
            $new_resultat->setRne($this->user->getRne());

            if ($new_resultat->save()){
              // rien  faire
            }else{
              $marqueur = false;
            }

          }elseif ($test[0] == 'nom'){
            # On a le nom, l'id de la grille et l'id du groupe
            $new_controle = new Controle();

            # On donne un nom  ce contrle
            $nom_controle = $this->_requete->controle['nom'] == '' ? 'Nom du controle  modifier !' : $this->_requete->controle['nom'];
            # On lui donne galement une date
            $testdate = explode("/", $this->_requete->controle['date']);
            $date = (count($testdate) == 3) ? mktime(2, 0, 0, $testdate[1], $testdate[0], $testdate[2]) : date('U');

            $new_controle->setNomcourt($nom_controle);
            $new_controle->setNomlong($this->_requete->controle['nom']);
            $new_controle->setRne($this->user->getRne());
            $new_controle->setCreatedOn($date);
            $new_controle->setGrilleId($this->_requete->controle['grilleId']);
            $new_controle->setGroupeId($this->_requete->controle['groupeId']);

            if ($new_controle->save()){
              // On ajoute ce contle  cet utilisateur
              $new_possesseur = new JControlePossesseur();
              $new_possesseur->setControleId($new_controle->getId());
              $new_possesseur->setUtilisateur($this->user);
              if ($new_possesseur->save()){
                // rien  faire
              }else{
                $this->setErreurMessage('Impossible d\'enregistrer ce propri&eacute;taire !');
                $this->redirect_to(array('action'=>'perso', 'info'=>'erreur'));
                exit();
              }

            }else{
              // On arrte tout
              $this->setErreurMessage('Impossible d\'enregistrer ce contr&ocirc;le !');
              $this->redirect_to(array('action'=>'perso', 'info'=>'erreur'));
              exit();
            }

          }

        }else{
          logControleur::insertLog('pirate', 1, 'Manque des infos pour enregistrer un rsultat : C::'.__CLASS__.'-A::'.__METHOD__, $this->user->getId());
          Die('Impossiblee d\'enregistrer ces r&eacute;sultats car il manque des informations ! Il ne faut pas modifier le code en secret !');
        }

      } // foreach

      # Tout est termin
      if ($marqueur === true){
        $this->setMessage('Evaluation enregistr&eacute;e !');
        $info = 'enregistre';
      }else{
        $info = 'erreur';
        $this->setErreurMessage('Une ou plusieurs erreurs ont &eacute;t&eacute; rep&eacute;r&eacute;es !');
      }
      $this->redirect_to(array('action'=>'perso', 'info'=>$info));
      exit();

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  } // ajouterResultatControle()

  /**
   * Pouvoir modifier les rsultats d'un contrle
   */
  public function modifier(){

    # Penser aux vrifications sur le RNE de l'utilisateur, si le prof possde bien ce contrle,...
    $test = ControlePeer::retrieveByPK($this->_params['info']);
    $marqueur = false;
    # On vrifie le possesseur
    foreach ($test->getJControlePossesseurs() as $profId) {
      if ($profId->getUtilisateurId() == $this->user->getId()){
        $marqueur = true;
      }
    }
    # On vrifie le RNE
    if ($test->getRne() != $this->user->getRne()){
      $marqueur = false;
    }

    if ($marqueur === false){
      $this->setErreurMessage('Vous ne pouvez pas modifier ce contr&ocirc;le !');
      logControleur::insertLog('pirate', 2, 'Modifie un controle qui n\'est pas  lui : C'.$this->_params['info'], $this->user->getId());
      $this->redirect_to(array('action'=>'perso', 'info'=>$this->user->getLogin()));
      exit();
    }

    //$c = new Criteria();
    //$c->addAscendingOrderByColumn(UtilisateurPeer::NOM);
    //$c->addAscendingOrderByColumn(UtilisateurPeer::PRENOM);
    //$c->addAscendingOrderByColumn(JControleResultatPeer::COMPETENCE_ID);

    //$test->getJControleResultatsJoinUtilisateur($c);
    //$this->affDebug($test);

    $this->_arrayTexte = $test;
  } // modifier()

  public function addModif(){

    if ($this->_requete->isPost() === true){
      // On vrifie que ce contrle appartient bien  ce professeur
      $controleId = $this->_requete->controleId;
      $c = new Criteria();
      $c->add(JControlePossesseurPeer::UTILISATEUR_ID, $this->user->getId());
      $c->add(JControlePossesseurPeer::CONTROLE_ID, $controleId);
      $test = JControlePossesseurPeer::doSelect($c);

      if (!empty ($test)){

        # On rcupre la liste des letters de validation possibles
        $lettres = ValidationNiveauPeer::listeNiveauxValidation();
        $marqueur = true; // marqueur pour vrifier si tous les enregistrements se passent bien.
        # C'est bon, ce prof possde bien ce contrle, on peut commencer la mise  jour de tous les rsultats
        foreach ($this->_requete->result as $cle => $valeur) {
          
          //// $cle = JControleResultat::ID et $valeur = resultat
          $eval = JControleResultatPeer::retrieveByPK($cle);
          if ($eval->getControleId() == $controleId){
            # On est certain que cette valuation fait bien partie de ce controle qui appartient bien  ce professeur
            if (array_key_exists($valeur, $lettres) OR $valeur == ''){ // permettre de virer une val  un lve
              $eval->setResultat($valeur);
            }else{
              $this->setErreurMessage('La lettre '.$valeur.' n\'est pas autoris&eacute;e !<br />');
              $marqueur = false;
            }
            if ($eval->save()){
              // rien  faire, on itre sur la suivante
            }
          }
        }
        // On envoie le bon message vers la bonne page
        if ($marqueur === true){
          $this->setMessage('Les modifications ont &eacute;t&eacute; enregistr&eacute;es !');
          $this->redirect_to(array('action'=>'modifier', 'info'=>$controleId));
          exit();
        }else{
          $this->setErreurMessage('Des erreurs ont &eacute;t&eacute; d&eacute;tect&eacute;es, v&eacute;rifiez les lettres utilis&eacute;es !');
          $this->redirect_to(array('action'=>'modifier', 'info'=>$controleId));
          exit();
        }
      }else{
        $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      }


    }
    $this->affDebug();
  }


  public function controle(){

    $c = new Criteria();
    $c->add(ControlePeer::RNE, $this->user->getRne());
    $c->add(ControlePeer::ID, $this->_params['info'], Criteria::EQUAL);
    $test = ControlePeer::doSelectJoinAll($c);

    if (count($test) === 1){
      $test1 = $test[0]->getJControlePossesseurs();
      $marqueur = false;
      # On teste pour voir si ce contrle appartient bien  cet utilisateur
      foreach ($test1 as $verif) {
        if ($verif->getUtilisateurId() == $this->user->getId()){
          $marqueur = true;
        }
      }
      if ($marqueur === true){
        $this->_arrayTexte = $test[0];
        # On ajoute un tableau des couleurs lies aux lettres
        $this->_couleurs = ValidationNiveauPeer::listeNiveauxValidation('color');
      }else{
        # Cet utilisateur tente de lire un contrle qui n'est pas  lui
        echo 'Vous tentez de lire un contr&ocirc;le qui ne vous appartient pas !
              <br />S\'il s\'agit d\'une erreur, prevenez votre administrateur, sinon ne modifiez jamais l\'adresse de votre navigateur  la main !';
        logControleur::insertLog('pirate', '2', 'Modification sauvage URL : C::'.__CLASS__.'-A::'.__METHOD__, $this->user->getId());
        exit();
      }
    }else{
      $_SESSION['erreurMsg'] = 'Impossible de trouver votre contr&ocirc;le !';
      $this->redirect_to(array('action'=>'perso', 'info'=>'erreur'));
      exit();
    }

  } // controle()

  /**
   * Permet  un lve de voir ses rsultats
   */
  public function eleve(){
    $this->_layout = 'eleve';

    $temps = PeriodePeer::getPeriodeActuelle($this->user->getRne());

    $c = new Criteria();
    $c->add(JControleResultatPeer::RNE, $this->user->getRne());
    $c->add(JControleResultatPeer::RESULTAT, '', Criteria::NOT_EQUAL);
    $c->add(JControleResultatPeer::UTILISATEUR_ID, $this->user->getId());
    $c->addJoin(JControleResultatPeer::CONTROLE_ID, ControlePeer::ID);
    $c->add(ControlePeer::CREATED_ON, $temps->getDebut(), Criteria::GREATER_EQUAL);
    $c->add(ControlePeer::CREATED_ON, $temps->getFin(), Criteria::LESS_EQUAL);
    $c->addJoin(ControlePeer::ID, JControlePossesseurPeer::CONTROLE_ID);
    $c->addAscendingOrderByColumn(JControlePossesseurPeer::UTILISATEUR_ID);
    $c->addAscendingOrderByColumn(ControlePeer::CREATED_ON);
    $c->addAscendingOrderByColumn(JControleResultatPeer::COMPETENCE_ID);
    
    $this->_arrayTexte = JControleResultatPeer::doSelectJoinCompetence($c);


  }

} 
?>