<?php
/**
 * @version $Id: exercicesControleur.php 45 2009-11-29 23:43:07Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of GEC. (http://www.sylogix.org/projects/show/gec)
 *
 * GEC is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GEC is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with GEC.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * Description de exercicesControleur
 *
 */

class exercicesControleur extends applicationControleur{

  public function index(){
    // rien pour le moment mais a peut servir  lister tous les exos de l'tablissement matire par matire.
  }

  /**
   * Pour afficher la liste des exercices d'un professeur
   */
  public function perso(){

    # L'aide
    $this->_aideMessage = '<p>Attention de donner un titre explicite &agrave; vos exercices car il sera ainsi plus facile
                           de les retrouver lors des associations avec les comp&eacute;tences et les niveaux de validation.</p>';

    # Un formulaire d'ajout
    $form = new formulaireHtml(array('name'=>'addExo', 'forme'=>'p', 'action'=>'ajouter'), $this->_params);
    $form->addInput(array('name'=>'titre', 'label'=>'Titre de l\'exercice : ', 'size'=>70));
    $form->addTextArea(array('name'=>'consigne', 'label'=>'Consigne : ', 'style'=>'width:85%;height:7em;'));
    $form->addSelect(array('name'=>'nbre_docs', 'label'=>'Nombre de documents : '), array(1=>1, 2=>2, 3=>3, 4=>4, 5=>5, 6=>6));
    $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    $this->form = $form;

    # On liste galement les exercices de ce professeurs
    $c = new Criteria();
    $c->add(ExercicePeer::RNE, $this->user->getRne());
    $c->add(ExercicePeer::PROFESSEUR_ID, $this->user->getId());
    $c->addAscendingOrderByColumn(ExercicePeer::TITRE);
    $this->_arrayTexte = ExercicePeer::doSelect($c);

  }

  /**
   * Permet  un professeur d'ajouter un exercice
   */
  public function ajouter(){

    if ($this->_requete->isPost() === true){

      # On vrifie si le titre est renseign et si la consigne aussi
      if ($this->_requete->addExo['titre'] == '' OR $this->_requete->addExo['consigne'] == ''){
        $this->setErreurMessage('Il faut renseigner le titre et la consigne, c\'est imp&eacute;ratif !');
        $this->redirect_to(array('action'=>'perso', 'info'=>'attention_au_titre_et_appreciation'));
        exit();
      }

      # On peut enregistrer cet exercice
      $exo = new Exercice();
      $exo->setProfesseurId($this->user->getId());
      $exo->setRne($this->user->getRne());
      $exo->setCreatedOn(date("U"));
      $exo->setTitre(htmlentities($this->_requete->addExo['titre']));
      $exo->setConsigne(htmlentities($this->_requete->addExo['consigne']));
      $exo->setNbreDocs(htmlentities($this->_requete->addExo['nbre_docs']));

      if ($exo->save()){
        $this->setMessage('Exercice enregistr&eacute; !');
        $this->redirect_to(array('action'=>'perso', 'info'=>'enregistre'));
        exit();
      }else{
        $this->setErreurMessage('Impossible d\'enregistrer cet exercice !');
        $this->redirect_to(array('action'=>'perso', 'info'=>'erreur'));
        exit();
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__.'::'.__LINE__, $this->user->getId());
    }

  } // ajouter()

  /**
   * Permet de modifier un exercice : ajouter les questions, proposer une aide affichable ou pas,...
   */
  public function modifier(){

    $this->_aideMessage = '<p class="red">Pour faire un exercice, seconde phase : </p>
                          <p>Vous devez pr&eacute;cisez le ou les documents (le nombre a &eacute;t&eacute; d&eacute;termin&eacute; lors de la cr&eacute;ation de l\'exercice)
                           ainsi que les questions. Pour chaque document, si vous choisissez un fichier, il sera pr&eacute;f&eacute;r&eacute; au texte.</p>';

    # On vrifie que cet utilisateur possde bien cet exercice
    $this->_texte = ExercicePeer::retrieveByPK($this->_params['info']);

    if ($this->_texte->getProfesseurId() != $this->user->getId()){
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__.'::'.__LINE__, $this->user->getId());
    }

  } // modifier()

}
?>
