<?php
/**
 * @version $Id: groupesControleur.php 5 2009-10-25 18:25:17Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */
   

// Controleur des groupes

class groupesControleur extends applicationControleur{

  public function index(){

    $this->_aideMessage = '<p>[<span class="blue">Cr&eacute;er un groupe</span>] permet de cr&eacute;er un groupe. </p>
                           <p>Pour s&eacute;lectionner plusieurs &eacute;l&egrave;ves, utilisez la touche [Ctrl].</p>';

    $this->_titre = 'Les groupes d\'&eacute;l&egrave;ves';

    $formulaire = new formulaireHtml(array('name'=>'ajoutergroupe', 'action'=>'ajouter', 'forme'=>'p'), $this->_params);
    $formulaire->addInput(array('name'=>'nomcourt', 'label'=>'Nom court du groupe : '));
    $formulaire->addInput(array('name'=>'nomlong', 'label'=>'Nom long : ', 'size'=>'40'));
    $formulaire->addSelect(array('name'=>'eleve', 'label'=>'Les lves : ', 'multiple'=>'on'), UtilisateurPeer::listeElevesForSelect(array('prof'=>$this->user->getId())));
    $formulaire->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    $this->form = $formulaire;

    $cr = new Criteria();

    if ($this->user->getRoleId() != 1 AND $this->user->getRoleId() != 5){
      $cr->add(JGroupePossesseurPeer::UTILISATEUR_ID, $this->user->getId());
    }
    if ($this->user->getRoleId() != 5){
      $cr->add(GroupePeer::RNE, $this->user->getRne());
    }
    $cr->addAscendingOrderByColumn(GroupePeer::NOMCOURT);
    $listeJoin = JGroupePossesseurPeer::doSelectJoinGroupe($cr);

    foreach ($listeJoin as $groupe) {
      $this->_arrayTexte[] = $groupe->getGroupe();
    }

  }

  public function ajouter(){

    if ($this->_requete->isPost() === true){

      if ($this->_requete->ajoutergroupe["nomcourt"] == ''){
        $_SESSION["erreurMsg"] = 'Il faut donner un nom (au moins court) &agrave; ce groupe !';
        $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
        exit();
      }

      $newGrp = new Groupe();
      $newGrp->setNomcourt(htmlentities($this->_requete->ajoutergroupe["nomcourt"]));
      $nomlong = ($this->_requete->ajoutergroupe["nomlong"] == '') ? $this->_requete->ajoutergroupe["nomcourt"] : $this->_requete->ajoutergroupe["nomlong"];
      $newGrp->setNomlong(htmlentities($nomlong));
      $newGrp->setRne($this->user->getRne());

      if ($newGrp->save()){
        // Il faut alors enregistrer la liste des lves
        $marqueur = true;
        foreach ($this->_requete->ajoutergroupe["eleve"] as $eleve) {
          if ($eleve != '0'){
            $elevegrp = new JGroupeEleve();
            $elevegrp->setGroupe($newGrp);
            $elevegrp->setUtilisateurId($eleve);
            if (!$elevegrp->save()){
              $marqueur = false;
            }
          }
        }

        # Si l'utilisateur n'est pas admin, il cre le groupe pour lui
        //if ($this->user->getRole()->getNom() !== 'admin'){ // STAND-BY
        //  revoir car si un admin cre des groupes pour les autres utilisateurs, qui a le droit de les supprimer ?
          # Il faut ajouter le possesseur
          $poss = new JGroupePossesseur();
          $poss->setGroupe($newGrp);
          $poss->setUtilisateur($this->user);
          if ($poss->save()){
            // rien
          }else{
            $marqueur = false;
          }
        //}

        if ($marqueur === true){
          $this->redirect_to(array('action'=>'index', 'info'=>'enregistre'));
          exit();
        }
      }else{
        $_SESSION["erreurMsg"] = 'Impossible d\'enregistrer ce groupe !';
        $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
        exit();
      }
    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      exit();
    }

  }

  public function modifier(){

    $test = GroupePeer::utilisateurPossedeCeGroupe($this->_params['info'], $this->user);
    if ($test !== false){

      $this->_arrayTexte = $test;

      # On contruit le formulaire de la liste des lves pour le proposer
      $form = new formulaireHtml(array('name'=>'ajoutEleve', 'forme'=>'p', 'action'=>'ajouterEleve', 'info'=>$this->_params['info']), $this->_params);
      $form->addSelect(array('name'=>'eleve', 'js'=>'onchange="document.ajoutEleve.submit();"'), UtilisateurPeer::listeElevesForSelect());
      //$form->addInput(array('name'=>'enregistrer', 'type'=>'submit', 'value'=>'Ajouter'));

      $this->form = $form;

    }else{
      $this->setErreurMessage('Ce groupe ne vous appartient pas, vous ne pouvez donc pas le modifier !');
      logControleur::insertLog('pirate', '1', 'Veut modifier un groupe qui ne lui appartient pas : GRPid='.$this->_params['info'], $this->user->getId());
      $this->redirect_to(array('action'=>'index', 'info'=>'pirate'));
      exit ();
    }

  }

  public function supprimerEleve(){

    $test = GroupePeer::utilisateurPossedeCeGroupe($this->_params['info'], $this->user);
    if ($test !== false){
      $c = new Criteria();
      $c->add(JGroupeElevePeer::GROUPE_ID, $this->_params['info'], Criteria::EQUAL);
      $c->add(JGroupeElevePeer::UTILISATEUR_ID, $this->_requete->getGet('eleve'), Criteria::EQUAL);
      JGroupeElevePeer::DoDelete($c);
      $this->redirect_to(array('action'=>'modifier'));
      exit();
    }else{
      $this->setErreurMessage('Ce groupe ne vous appartient pas, vous ne pouvez donc pas le modifier !');
      logControleur::insertLog('pirate', '1', 'Veut modifier un groupe qui ne lui appartient pas : GRPid='.$this->_params['info'], $this->user->getId());
      $this->redirect_to(array('action'=>'index', 'info'=>'pirate'));
      exit ();
    }

  }

  public function ajouterEleve(){

    if ($this->_requete->isPost() === true){
      $test = GroupePeer::utilisateurPossedeCeGroupe($this->_params['info'], $this->user);
      if ($test !== false){

        $new = new JGroupeEleve();
        $new->setGroupeId($this->_params['info']);
        $new->setUtilisateurId($this->_requete->ajoutEleve['eleve']);

        if ($new->save()){
          $this->redirect_to(array('action'=>'modifier'));
          exit ();
        }else{
          $this->setErreurMessage('Impossible d\'enregistrer ce nouvel lve !');
          $this->redirect_to(array('action'=>'modifier'));
          exit();
        }

      }else{
        $this->setErreurMessage('Ce groupe ne vous appartient pas, vous ne pouvez donc pas le modifier !');
        logControleur::insertLog('pirate', '1', 'Veut modifier un groupe qui ne lui appartient pas : GRPid='.$this->_params['info'], $this->user->getId());
        $this->redirect_to(array('action'=>'index', 'info'=>'pirate'));
        exit ();
      }

    }

  }

  public function effacer(){

    if ($this->_requete->isGet() === true AND $_GET['e'] == 'r'){
      // On teste si ce groupe appartient bien  cet utilisateur
      $grp = GroupePeer::utilisateurPossedeCeGroupe($this->_params['info'], $this->user);
      if ($grp !== false){

        # On vrifie maintenant que ce groupe ne possde pas de grille
        $tab = array();
        $tab = $grp->getJGrilleGroupes();
        if (!empty ($tab)){
          $_SESSION["erreurMsg"] = 'Impossible d\'effacer ce groupe car il poss&egrave;de une grille de comp&eacute;tences !';
          $this->redirect_to(array('action'=>'index', 'info'=>'erreur'));
          exit();
        }

        # On efface maintenant la liste des lves de ce groupe
        $cr = new Criteria();
        $cr->add(JGroupeElevePeer::GROUPE_ID, $this->_params['info'], Criteria::EQUAL);
        $effeleves = JGroupeElevePeer::doDelete($cr);
        $cr = new Criteria();
        $cr->add(JGroupePossesseurPeer::GROUPE_ID, $this->_params['info'], Criteria::EQUAL);
        $effpossesseurs = JGroupePossesseurPeer::doDelete($cr);

        $eff = GroupePeer::doDelete($this->_params['info']);

        $this->redirect_to(array('action'=>'index', 'info'=>'efface'));
      }else{
        $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      }

    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

  }

} 
?>