<?php
/**
 * @version $Id: loginControleur.php 2 2009-10-25 12:25:37Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

/**
 * Controleur du login
 *
 * @author Julien Jocal
 */
class loginControleur extends applicationControleur{

  public function index(){

    # On vrifie si CAS a dj identifi l'utilisateur et si la session est dj prsente
//  http://localhost/competencesRB/accueil/index/-
    if (isset($_SESSION["user"]) AND $_SESSION["user"] != ''){
      $this->redirect_to(array('controleur'=>'accueil', 'action'=>'index', 'info'=>$this->user->getLogin()));
      exit();
    }

    $this->_layout = 'login';
    $this->_title = $this->_titre = 'Identifiez-vous !';

    $this->_texte = 'On teste encore !!';

    $this->formulaireLogin();

  }

  public function testLogin(){

    if (!isset ($_SESSION) OR !array_key_exists('user', $_SESSION)){
      $this->setErreurMessage('Vous avez d&ucirc; faire une erreur sur le login ou le mot de passe !');
      $this->redirect_to(array('controleur' => 'login', 'action' => 'index', 'info' => 'test'));
      exit();
    }else{
      $this->redirect_to(array('controleur' => 'accueil', 'action' => 'index', 'info' => $_SESSION["user"]->getLogin()));
      exit();
    }

  }

  public function logout(){
    $this->_layout = 'login';
    authControleur::logout();
    
  }

  private function formulaireLogin($defaultValues = array()){

    $this->form = new formulaireHtml(array('name' => 'testlogin', 'action' => 'testLogin', 'forme'=>'p'), $this->_params);
    $this->form->addInput(array('name'=>'login', 'value' => traitementHelper::valueInArray($defaultValues, "login"), 'label'=>'Votre identifiant : '));
    $this->form->addInput(array('type' =>'password', 'name'=>'password', 'value' => traitementHelper::valueInArray($defaultValues, "mdp"), 'label' => 'Votre mot de passe : '));
    $this->form->addInput(array('type' => 'submit', 'name'=>'envoyer', 'value' => 'Envoyer'));

  }

}
?>
