<?php
/**
 * @version $Id: utilisateursControleur.php 34 2009-11-16 10:01:58Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of competencesRB.
 *
 * competencesRB is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * competencesRB is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with competencesRB.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * You should have received a copy of the GNU General Public License
 * along with superGepi.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

/**
 * Description of utilisateursControleur
 *
 * @author jjocal
 */
class utilisateursControleur extends applicationControleur {

  /**
   * Cette action permet de lister les utilisateurs existants et d'en ajouter si on en a le droit
   */
  public function index(){

    $form = new formulaireHtml(array('name'=>'adduser', 'forme'=>'p', 'action'=>'ajouter'), $this->_params);
    $form->addSelect(array('name'=>'civilite', 'label'=>'Civilit&eacute; : '), array('M'=>'M.', 'Mlle'=>"Mlle", 'Mme'=>'Mme'));
    $form->addInput(array('type'=>'text', 'name'=>'nom', 'value'=>'', 'label'=>'Nom : '));
    $form->addInput(array('type'=>'text', 'name'=>'prenom', 'value'=>'', 'label'=>'Pr&eacute;nom : '));
    $form->addInput(array('type'=>'text', 'name'=>'login', 'value'=>'', 'label'=>'Identifiant : '));
    if ($this->user->getRole()->getNom() == 'superadmin'){
      $form->addSelect(array('name'=>'rne', 'label'=>'Sur quel &eacute;tablissement ?', 'selected'=>$this->user->getRne()), etablissementPeer::listeEtablissementsForSelect());
    }
    $form->addInput(array('type'=>'text', 'name'=>'password', 'value'=>'', 'label'=>'Mot de passe : '));
    $form->addInput(array('type'=>'text', 'name'=>'naissance', 'value'=>'', 'label'=>'Date de naissance JJ/MM/AAAA'));
    $form->addInput(array('type'=>'text', 'name'=>'email', 'value'=>'', 'label'=>'Courriel (&eacute;mail) : '));
    $form->addSelect(array('name'=>'role', 'label'=>'Role : '), rolePeer::listeRolesForSelect());
    $form->addSelect(array('name'=>'matiere', 'label'=>'Mati&egrave;re (si &eacute;l&egrave;ve) : '), MatierePeer::listeMatieresForSelect());
    $form->addSelect(array('name'=>'classe', 'label'=>'Classe (si &eacute;l&egrave;ve) : '), UtilisateurPeer::listeClasseForSelect());
    $form->addSelect(array('name'=>'sso', 'label'=>'SSO : '), array('o'=>'Oui', 'n'=>'Non'));
    $form->addInput(array('type'=>'submit', 'name'=>'ajouter', 'value'=>'Ajouter'));


    $this->form = $form;

    // On affiche la liste des pompiers en fonction de l'info (par dfaut, c'est le nom de famille)
    $c = new Criteria();
    if ($this->_params["info"] == 'role'){
      $c->addAscendingOrderByColumn(UtilisateurPeer::ROLE_ID);
    }
    if ($this->user->getRole()->getNom() != "superadmin"){
      $c->add(UtilisateurPeer::RNE, $this->user->getRne());
    }elseif(!isset($_GET['rne'])){
      $c->add(UtilisateurPeer::RNE, $this->user->getRne()); // Par dfaut, un superadmin ne voit que ses utilisateurs
    }elseif(isset($_GET['rne']) AND $this->user->getRole()->getNom() == "superadmin"){
      $c->add(UtilisateurPeer::RNE, $_GET['rne']);
    }
      $c->addAscendingOrderByColumn(UtilisateurPeer::NOM);
      $c->addAscendingOrderByColumn(UtilisateurPeer::PRENOM);

    $this->_arrayTexte = UtilisateurPeer::doSelect($c);

  }

  public function ajouter(){

    if ($this->_requete->isPost() === true){
      // Il existe alors un tableau de rponses
      $newUser = $this->_requete->adduser; // c'est un array

      // On traite la date de naissance
      $date = explode ("/", $newUser["naissance"]);
      if (count($date) < 3 OR count($date) > 3){
        $_SESSION["erreurMsg"] = 'La date n\'est pas correcte, elle doit &ecirc;tre de la forme JJ/MM/AAAA';
        $this->redirect_to(array('action' => 'index'));
        exit();
      }
      $naissance = mktime(3, 0, 0, $date[1], $date[0], $date[2]);
      $_rne = $this->user->getRole()->getNom() != 'superadmin' ? $this->user->getRne() : $newUser["rne"];

      $utilisateur = new Utilisateur();
      $utilisateur->setCivilite($newUser["civilite"]);
      $utilisateur->setNom(htmlentities($newUser["nom"]));
      $utilisateur->setPrenom(htmlentities($newUser["prenom"]));
      $utilisateur->setLogin(htmlentities($newUser["login"]));
      $utilisateur->setRne(htmlentities($_rne));
      $utilisateur->setPassword(md5($newUser["password"]));
      $utilisateur->setNaissance($naissance);
      $utilisateur->setEmail($newUser["email"]);
      $utilisateur->setRoleId($newUser["role"]);
      $utilisateur->setClasseId($newUser["classe"]);
      $utilisateur->setMatiereId($newUser["matiere"]);
      $utilisateur->setSso($newUser['sso']);

      if ($utilisateur->isLoginUniqueAndSave()){
        $this->redirect_to(array('action'=>'index'));
        exit();

      }else{
        $_SESSION["erreurMsg"] = 'Ce login existe d&eacute;j&agrave;';
        $this->redirect_to(array('action' => 'index'));
        exit();
      }

    }

  } // ajouter()

  public function ajouterUtilisateurs(){

    if ($this->_requete->isPost() === true AND $this->_requete->envoyer == 'Envoyer'){

      # On a besoin de quelques tableaux de GEC
      $liste_classe = UtilisateurPeer::listeClasseForSelect();

      // Premier CAS : le fichier csv
      if ($this->_requete->type == 'csv'){
        # On commence par vrifier si le fichier est le bon et a la bonne structure
        $fichier = $_FILES['csv']['tmp_name'];

        $open = fopen($fichier, 'r');
        $iter = 1;
        while ($ligne = fgetcsv($open, 8000, ";")){
          $nbre = count($ligne);
          if ($nbre != 8){
            $this->setErreurMessage('La structure du fichier doit comport&eacute;e 8 champs comme sur le mod&egrave;le !');
            $this->redirect_to(array('info'=>'erreur'));
            exit();
          }
          ++$iter;
          # On commence le traitement de la premire ligne
          if ($ligne[0] == 'rne'){
            //break;// On ne fait rien
          }else{
            # On traite les utilisateurs (le RNE sera celui de l'admin qui fait le traitement)
            # rne;login;mdp;nom;prenom;categorie;discipline;classe
            $user = new Utilisateur();
            $user->setRne($this->user->getRne());
            $user->setPassword($ligne[2]);
            $user->setNom(htmlentities($ligne[3]));
            $user->setPrenom(htmlentities($ligne[4]));
            $user->setSso($this->_requete->sso);
            if ($ligne[5] == 'ENSEIGNANT'){
              # professeur
              $user->setRoleId(4);
            }elseif($ligne[5] == 'DIRECTION'){
              # admin
              $user->setRoleId(1);
            }else{
              # lve
              $user->setRoleId(3);
            }
            # Si c'est un lve, il faut le mettre dans une classe
            if ($user->getRoleId() == 3){
              $user->setClasseId(ClassePeer::verifierClasseEtCreer($ligne[7], $this->user));
            }
            # Si c'est un professeur, il faut lui mettre sa discipline
            if ($user->getRoleId() == 4){
              $user->setMatiereId(MatierePeer::verifierMatiereEtCreer($ligne[6], $this->user));
            }

            # Il ne reste plus que le login
            $user->setLogin(htmlentities($ligne[1]));
            if ($user->isLoginUniqueAndSave()){
              // rien  faire
            }else{
              # Le login existe dj, on doit donc en crer un nouveau
              for ($iter = 1 ; $iter < 20 ; ++$iter){
                $user->setLogin(htmlentities($ligne[1]).$iter);
                if ($user->isLoginUniqueAndSave()){
                  break; // On sort de la boucle
                }
              }
            }

          }
        }
        fclose($open); // on referme proprement la ressource

        # et on renvoit sur la bonne page
        $this->setMessage($iter.' utilisateurs ont &eacute;t&eacute; ajout&eacute;s &agrave; la base de votre tablissement ('.$this->user->getRne().')');
        $this->redirect_to(array('info'=>'enregistre'));
        exit();

      // Deuxime cas : le XML de sconet ElevesSansAdresse.xml
      }elseif ($this->_requete->type == 'sconet'){

        # On commence par vrifier si le fichier est le bon et a la bonne structure
        $fichier = $_FILES['sconet']['tmp_name'];
        $xml = simplexml_load_file($fichier);
        # On vrifie si c'est le bon RNE
        if ($xml->PARAMETRES->UAJ != $this->user->getRne()){
          $this->setErreurMessage('Vous devez avoir le m&ecirc;me RNE que le fichier !');
          $this->redirect_to(array('info'=>'erreur'));
          exit();
        }else{

          # On peut alors parser le fichier pourrcuprer tous les lves
          $iter = 0;
          foreach ($xml->DONNEES->ELEVES->ELEVE as $eleve) {
            if (!isset($eleve->DATE_SORTIE)){
              $_login = isset($eleve->ID_NATIONAL) ? $eleve->ID_NATIONAL : $eleve->ELENOET.'_'.htmlentities(utf8_decode($eleve->NOM));
              $test = @explode("/", $eleve->DATE_NAISS);
              $_naissance = isset($eleve->DATE_NAISS) ? @mktime(2, 0, 0, $test[1], $test[0], $test[2]) : 0;
              $new = new Utilisateur();
              $new->setRne($this->user->getRne());
              $new->setNom(htmlentities(utf8_decode($eleve->NOM)));
              $new->setPrenom(htmlentities(utf8_decode($eleve->PRENOM)));
              $new->setLogin($_login);
              $new->setNaissance($_naissance);
              $new->setPassword($eleve->ELENOET); // On peut alors s'en servir pour lui ajouter la classe
              $new->setRoleId(3); // lve

              /* @TODO : il faut lui donner sa classe aussi :) */
 //========================================================================================//

              ++$iter;
            }
          }

        }

      // Troisime cas : le XML de STS
      }elseif ($this->_requete->type == 'sts'){
        $this->affDebug($_FILES);
      }
    }

  } // ajouterUtilisateurs()

  /**
   * Modifie les donnes d'un utilisateur
   */
  public function modifUtilisateur(){

    # On vrifie si cet utilisateur existe et appartient bien  cet tablissement
    $c = new Criteria();
    $c->add(UtilisateurPeer::RNE, $this->user->getRne());
    $c->add(UtilisateurPeer::ID, $this->_params['info']);
    $test = UtilisateurPeer::doSelect($c);
    if (!empty ($test)){
      $testuser = $test[0];
    }else{
      $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
    }

    $form = new formulaireHtml(array('name'=>'modifUser', 'action'=>'addModifUtilisateur', 'info'=>'modifier', 'forme'=>'p'), $this->_params);
    $form->addInput(array('name'=>'userId', 'type'=>'hidden', 'value'=>$testuser->getId()));
    $form->addInput(array('name'=>'login', 'value'=>$testuser->getLogin()));
    $form->addInput(array('name'=>'nom', 'value'=>$testuser->getNom()));
    $form->addInput(array('name'=>'prenom', 'value'=>$testuser->getPrenom()));
    $form->addInput(array('name'=>'naissance', 'value'=>date("d/m/Y", $testuser->getNaissance())));
    if ($testuser->getRole()->getNom() == 'eleve'){
      $form->addSelect(array('name'=>'classe', 'selected'=>$testuser->getClasseId()), UtilisateurPeer::listeClasseForSelect());
    }else{
      # Pour les autres utilisateurs, on leur mets toutes leurs classes s'il y en a
      $classes_de_cet_user = $testuser->getJProfesseurClassess();
      $tab = array();
      foreach ($classes_de_cet_user as $classe_user) {
        $tab[] = $classe_user->getClasseId();
      }
      $c = new Criteria();
      $c->add(ClassePeer::RNE, $testuser->getRne());
      $c->addAscendingOrderByColumn(ClassePeer::NOM);
      $classes = ClassePeer::doSelect($c);
      $iter = 0; // itrateur
      foreach ($classes as $classe) {
        $aff_checked = (in_array($classe->getId(), $tab)) ? 'on' : 'off';

        $form->addInput(array('type'=>'checkbox', 'name'=>'classe', 'id'=>'idC'.$iter, 'label'=>$classe->getNom(), 'checked'=>$aff_checked, 'multiple'=>'on', 'value'=>$classe->getId()));
        ++$iter;
      }
      # et on n'oublie pas la matire
      $form->addSelect(array('name'=>'matiere', 'selected'=>$testuser->getMatiereId()), MatierePeer::listeMatieresForSelect());
    }
    $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Mettre &agrave; jour !'));

    $this->form = $form;

  }
  /**
   * Enregistre les modifications sur un lves
   */
  public function addModifUtilisateur(){

    $marqueur = false; // pour garder une trace
    if ($this->_requete->isPost() === true){
      # On peut mettre  jour cet lve (on vrifie encore s'il est bien de cet tablissement
      $c = new Criteria();
      $c->add(UtilisateurPeer::ID, $this->_requete->modifUser['userId']);
      $c->add(UtilisateurPeer::RNE, $this->user->getRne());
      $test = UtilisateurPeer::doSelect($c);
      if (!empty ($test)){
        $testuser = $test[0];
      }else{
        $this->dehorsUtilisateur('', __CLASS__, __METHOD__, $this->user->getId());
      }

      $testNaissance = explode("/", $this->_requete->modifUser['naissance']);
      if (count($testNaissance) == 3 AND strlen($testNaissance[2]) == 4){
        $naissance = mktime(2, 0, 0, $testNaissance[1], $testNaissance[0], $testNaissance[2]);
      }else{
        $this->setErreurMessage('Le format de la date doit &ecirc; JJ/MM/AAAA');
        $this->redirect_to(array('action'=>'modifUtilisateur', 'info'=>$this->_requete->modifUser['userId']));
        exit();
      }

      $testuser->setLogin($this->_requete->modifUser['login']);
      $testuser->setNom($this->_requete->modifUser['nom']);
      $testuser->setPrenom($this->_requete->modifUser['prenom']);
      $testuser->setNaissance($naissance);

      if ($testuser->getRole()->getNom() == 'eleve'){
        $testuser->setClasseId($this->_requete->modifUser['classe']);
      }elseif ($testuser->getRole()->getNom() == 'professeur' OR $testuser->getRole()->getNom() == 'Coordinateur'){
        # On traite la liste de ses classes aprs avoir effacer la liste de ceux qui le concerne
        $c = new Criteria();
        $c->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->_requete->modifUser['userId']);
        JProfesseurClassesPeer::doDelete($c);

        if (array_key_exists('classe', $this->_requete->modifUser)){
          $marqueur = true;
          foreach ($this->_requete->modifUser['classe'] as $classe_id){
            # On ajoute les classes de ce professeur
            $addClasse = new JProfesseurClasses();
            $addClasse->setProfesseurId($testuser->getId());
            $addClasse->setClasseId($classe_id);
            $addClasse->save();
          }
        }
        # On traite la matire
        $testuser->setMatiereId($this->_requete->modifUser['matiere']);
      }else{
        // rien
      }

      if ($testuser->save() OR $marqueur === true){
        $this->setMessage('Modifications enregistr&eacute;es !');
        $this->redirect_to(array('action'=>'index', 'info'=>'tous'));
        exit();
      }else{
        $this->setErreurMessage('Impossible de mettre &agrave; jour cet utilisateur !');
        $this->redirect_to(array('action'=>'modifUtilisateur', 'info'=>$this->_requete->modifUser['userId']));
        exit();

      }

    }

  }

  public function perso(){

    $this->_titre = $this->_title = 'Mon profil personnel';

    $c = new Criteria();
    $c->add(JProfesseurClassesPeer::PROFESSEUR_ID, $this->user->getId());
    $c->add(ClassePeer::RNE, $this->user->getRne());
    $c->addAscendingOrderByColumn(ClassePeer::NOM);
    $mes_classes = JProfesseurClassesPeer::doSelectJoinClasse($c);

    $this->_arrayTexte = $mes_classes;

    $form = new formulaireHtml(array('name'=>'modifierMdp', 'action'=>'modifMdp', 'info'=>$this->user->getId(), 'forme'=>'p'), $this->_params);
    $form->addInput(array('type'=>'password', 'name'=>'exmdp', 'label'=>'Ancien mot de passe :'));
    $form->addInput(array('type'=>'password', 'name'=>'mdp1', 'label'=>'Nouveau mot de passe :'));
    $form->addInput(array('type'=>'password', 'name'=>'mdp2', 'label'=>'Le m&ecirc;me mot de passe :'));
    $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    $this->form = $form;
    # Pour CAS, on limine le formulaire
    if ($this->_auth->getMode() == 'cas'){
      $this->form = new formulaireHtml(array(), $this->_params);
      $this->form->addLegende('Vous ne pouvez pas modifier le mot de passe ici &agrave; cause du SSO !');
    }

  }

  public function eleve(){
    $this->_layout = 'eleve';
    $this->_titre = $this->_title = 'Mon profil personnel';

    $this->_arrayTexte = $this->user;

  }

  public function modifMdp(){

    if ($this->_requete->isPost() === true){

      # On vrifie si le mot de passe ancien est le bon
      if (md5($this->_requete->modifierMdp['exmdp']) == $this->user->getPassword()){
        # On vrifie alors si le mdp1 et le mdp2 sont identiques
        if ($this->_requete->modifierMdp['mdp1'] == $this->_requete->modifierMdp['mdp2']){
          # On modifie alors le mdp
          $user = UtilisateurPeer::retrieveByPK($this->user->getId());
          $user->setPassword(md5($this->_requete->modifierMdp['mdp2']));
          if ($user->save()){
            $this->setMessage('La modification a bien &eacute;t&eacute; enregistr&eacute;e !');
            $this->redirect_to(array('action'=>'perso', 'info'=>'modifie'));
            exit();
          }
        }else{
          $this->setErreurMessage('Les deux nouveaux mots de passe doivent &ecirc;tre identiques !');
          $this->redirect_to(array('action'=>'perso', 'info'=>'erreur_sur_mdp'));
          exit();
        }
      }else{
        $this->setErreurMessage('Il y a une erreur sur l\'ancien mot de passe !');
        $this->redirect_to(array('action'=>'perso', 'info'=>'erreurAncienMdp'));
        exit();
      }

    }

  }

  public function effacer(){

      // On peut effacer l'utilisateur en question si ce n'est pas l'admin
      if ($this->_requete->isGet() === true){
        $c = new Criteria();
        $c->add(UtilisateurPeer::ID, $this->_params["info"], Criteria::EQUAL);
        $test = UtilisateurPeer::doSelect($c);

        if (empty ($test)){

          $this->setErreurMessage('Cet utilisateur n\'existe pas !');
          $this->redirect_to(array('action'=>'index', 'info'=>$this->user->getLogin()));
          exit();

        }elseif ($test[0]->getLogin() == 'admin'){

          $this->setErreurMessage('Il ne faut pas effacer l\'administrateur de l\'application');
          $this->redirect_to(array('action'=>'index', 'info'=>$this->user->getLogin()));
          exit();

        }else{

          if (!is_null($this->_requete->getGet('r'))){

            # On vrifie que cet utilisateur n'a pas dj des rsultats, n'appartient pas  un groupe, n'a pas de bilan, des apprciations, ...
            $c = new Criteria();
            $c->add(JGroupeElevePeer::UTILISATEUR_ID, $this->_params["info"]);
            JGroupeElevePeer::doDelete($c);
            $c = new Criteria();
            $c->add(JControleResultatPeer::UTILISATEUR_ID, $this->_params["info"]);
            JControleResultatPeer::doDelete($c);
            $c = new Criteria();
            $c->add(BilanPeer::ELEVE_ID, $this->_params["info"]);
            BilanPeer::doDelete($c);
            $c = new Criteria();
            $c->add(AppreciationPeer::ELEVE_ID, $this->_params["info"]);
            AppreciationPeer::doDelete($c);

            UtilisateurPeer::doDelete($this->_params["info"]);
            $this->setMessage('Utilisateur effac&eacute; !');
            $this->redirect_to(array('action'=>'index', 'info'=>$this->user->getLogin()));
            exit();
          }
        }

      }else{
        logControleur::insertLog('erreur', 1, 'Modifier le chemin url manuellement Utilisateur::effacer', $this->user->getId());
        authControleur::logout();
        $this->redirect_to(array('controleur'=>'login', 'action'=>'login', 'info'=>'bad'));
        exit();
      }
      $this->redirect_to(array('action' => 'index'));
      exit();
  }

  public function listetab(){

    $this->_titre = 'Liste des &eacute;tablissements';

    # Par dfaut, seul le superadmin a le droit de lister les tablissements de l'application
    $c = new Criteria();
    $c->addAscendingOrderByColumn(etablissementPeer::CODEPOSTAL);
    $this->_arrayTexte = etablissementPeer::doSelect($c);

  }

  public function ajaxVoirEtab(){
    $c = new Criteria();
    $c->add(UtilisateurPeer::RNE, substr($this->_requete->_id, 8, 17));
    $c->addAscendingOrderByColumn(UtilisateurPeer::ROLE_ID);
    $c->addAscendingOrderByColumn(UtilisateurPeer::NOM);
    $c->addAscendingOrderByColumn(UtilisateurPeer::PRENOM);
    $liste_users = UtilisateurPeer::doSelect($c);
    foreach ($liste_users as $user) {
      echo '<span>['.$user->getRole()->getNom().']'.$user->getNom().' '.$user->getPrenom().' ('.$user->getRne().')</span><br />'."\n";
    }
    exit();
  }

  /**
   * Francise la date
   *
   * @param string $option mois
   * @return string
   */
  public function dateFr($mois){

    $array = array('janvier', 'f&eacute;vrier', 'mars', 'avril', 'mai', 'juin', 'juillet', 'ao&ucirc;t', 'septembre', 'octobre', 'novembre', 'd&eacute;cembre');

    return $array[$mois - 1];
  }

  public function profprincipaux(){

    if ($this->_requete->isPost() === true){
      # On efface la liste des PP
      $c = new Criteria();
      $c->add(JProfesseurPrincipalClassesPeer::CLASSE_ID, ClassePeer::listeClassesId($this->user), Criteria::IN);
      $del = JProfesseurPrincipalClassesPeer::doDelete($c);

      foreach ($this->_requete->profprincipaux as $cle => $valeur) {
        if ($valeur != '0' AND $cle != 0){
          $add = new JProfesseurPrincipalClasses();
          $add->setProfesseurId($valeur);
          $add->setClasseId($cle);
          $add->save();
        }
      }
      $this->setMessage('Professeurs principaux enregistr&eacute;s !');
    }

    # On construit le formulaire
    $c = new Criteria();
    $c->add(ClassePeer::RNE, $this->user->getRne());
    $c->addAscendingOrderByColumn(ClassePeer::NOM);
    $classes = ClassePeer::doSelect($c);

    $form = new formulaireHtml(array('name'=>'profprincipaux', 'forme'=>'td'), $this->_params);
    foreach ($classes as $classe) {
      $form->addTag('tr');
      $form->addSelect(array('name'=>$classe->getId(), 'selected'=>$this->_requete->profprincipaux[$classe->getId()], 'label'=>$classe->getNom()), UtilisateurPeer::listeProfesseursCetteCLasseForSelect($classe->getId()));
      $form->addTag('/tr');
    }
    $form->addInput(array('type'=>'submit', 'name'=>'enregistrer', 'value'=>'Enregistrer'));

    $this->form = $form;

  } // profprincipaux()

}
?>