<?php
/**
 * @version $Id: traitement.class.php 2 2009-10-25 12:25:37Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of miniFramework.
 *
 * miniFramework is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * miniFramework is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with miniFramework.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

/**
 * La classe traitementHelper
 *
 * @author jjocal
 */
class traitementHelper {

  /**
   * Teste s'il s'agit d'une chaine de caractres et le renvoie ($defaut si ce n'est pas une chaine)
   *
   * @param string $string
   * @param string $defaut
   * @return string texte
   */
  public static function returnIfIsString($string, $defaut = NULL){
    if (is_string($string)){
      return $string;
    }else{
      return $defaut;
    }
  }

  /**
   * Renvoie la valeur d'un champ si il existe, sinon renvoie la valeur par dfaut (qui est nulle si elle n'est pas prcise).
   *
   * @param array $tab le tableauanalys
   * @param string $valeur le champ recherch
   * @param string $default si le champ n'existe pas, on renvoie cette valeur
   * @return string $tab[$valeur] ou $default
   */
  public static function valueInArray($tab, $valeur, $default = NULL){

    if (!is_array($tab)){
      return $default;
    }

    if (array_key_exists($valeur, $tab)){
      return $tab[$valeur];
    }else{
      return $default;
    }
  }

}
?>
