<?php
/**
 * @version $Id: logControleur.php 2 2009-10-25 12:25:37Z jjocal $
 * @author Julien Jocal
 * @copyright 2009 Julien Jocal
 *
 * This file is part of miniframework.
 *
 * miniframework is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * miniframework is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details (COPYING).
 *
 * You should have received a copy of the GNU General Public License
 * along with miniframework.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

/**
 * Le logControleur permet de grer tousles logs de l'application en fonction de leur type, degr,...
 *
 * @author jjocal
 */
class logControleur {

  protected function  __construct() {
    return false;
  }

  /**
   * Mthode statique qui permet d'enregistrer un log dans la table adquate. Cete table :
   * log(id, type, degre, message, referer, navigateur, utilisateur_id, created_on, updated_on).
   *
   * @param string $type session/pirate/create/insert...
   * @param integer $degre Degr de gravit du log
   * @param string $message Message enregistr dans le log
   * @param integer $utilisateurId identifiant de l'utilisateur
   */
  public static function insertLog($type, $degre, $message, $utilisateurId){

    $log = new Log;
    $log->setType($type);
    $log->setDegre($degre);
    $log->setTexte(htmlentities($message));
    $log->setUtilisateurId($utilisateurId);
    $log->setDebut(date("U"));
    $log->setIp($_SERVER["REMOTE_ADDR"]);
    $log->setNavigateur($_SERVER["HTTP_USER_AGENT"]);

    $log->save();

    return $log->getId();

  }

}
?>
