<?php

require 'competencesrb/om/BaseGroupePeer.php';


/**
 * Skeleton subclass for performing query and update operations on the 'groupes' table.
 *
 * Liste des groupes
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    competencesrb
 */
class GroupePeer extends BaseGroupePeer {

  public static function listeGroupesForSelect(utilisateur $user, $type = NULL){

    $c = new Criteria();
    $c->addAscendingOrderByColumn(GroupePeer::NOMCOURT);
    if ($type == 'perso'){
      $c->add(JGroupePossesseurPeer::UTILISATEUR_ID, $user->getId(), Criteria::EQUAL);
    }
    $test = JGroupePossesseurPeer::doSelectJoinAll($c);

    $tab = array();
    $tab[0] = ' -- Liste des groupes -- ';
    foreach ($test as $grp) {
      $tab[$grp->getGroupeId()] = $grp->getGroupe()->getNomcourt();
    }

    return $tab;

  }

  /**
   * Teste si un groupe appartient bien  un utilisateur et renvoie le groupe si c'est le cas
   *
   * @param integer $groupeId
   * @param object $user utilisateur
   * @return boulean true/objet Groupe
   */
  public static function utilisateurPossedeCeGroupe($groupeId, utilisateur $user){

    $c = new Criteria();
    $c->add(JGroupePossesseurPeer::GROUPE_ID, $groupeId, Criteria::EQUAL);
    $c->add(JGroupePossesseurPeer::UTILISATEUR_ID, $user->getId(), Criteria::EQUAL);
    $test = JGroupePossesseurPeer::doSelect($c);

    if (empty ($test)){
      return false;
    }else{
      return GroupePeer::retrieveByPK($test[0]->getGroupeId());
    }

  }

} // GroupePeer
