<?php

require 'competencesrb/om/BasePeriodePeer.php';


/**
 * Skeleton subclass for performing query and update operations on the 'periodes' table.
 *
 * Liste des periode de l'annee
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package    competencesrb
 */
class PeriodePeer extends BasePeriodePeer {

  public static function getPeriodeActuelle($rne){

    $c = new Criteria();
    $c->add(PeriodePeer::DEBUT, date('U'), Criteria::LESS_EQUAL);
    $c->add(PeriodePeer::FIN, date('U'), Criteria::GREATER_EQUAL);
    $c->add(PeriodePeer::RNE, $rne);
    $test = self::DoSelect($c);

    if (empty ($test)){
      Die('Attention, aucune p&eacute;riode n\'est d&eacute;finie dans l\'application, pr&eacute;venez votre administrateur !');
    }elseif(count($test) >= 2){
      Die('Attention, plusieurs p&eacute;riode ont des dates qui se chevauchent, pr&eacute;venez votre administrateur !');
    }else{
      return $test[0];
    }

  } // getPeriodeActuelle()

  /**
   * Renvoie une liste des periodes non termines sous la forme $tab[id] = nom
   *
   * @return array tableau des objets periode
   */
  public static function listeForSelect($rne){

    $c = new Criteria();
    $c->add(PeriodePeer::RNE, $rne);
    $c->add(PeriodePeer::FIN, date("U"), Criteria::GREATER_EQUAL);
    $periodes = PeriodePeer::doSelect($c);
    $tab = array ();
    $tab['nulle'] = 'aucune';
    foreach ($periodes as $periode) {
      $tab[$periode->getId()] = $periode->getNom();
    }
    return $tab;
  }

} // PeriodePeer
