<?php


/**
 * This class adds structure of 'bulletin_transversales' table to 'competencesrb' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    competencesrb.map
 */
class JBulletinTransversalesMapBuilder implements MapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'competencesrb.map.JBulletinTransversalesMapBuilder';

	/**
	 * The database map.
	 */
	private $dbMap;

	/**
	 * Tells us if this DatabaseMapBuilder is built so that we
	 * don't have to re-build it every time.
	 *
	 * @return     boolean true if this DatabaseMapBuilder is built, false otherwise.
	 */
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	/**
	 * Gets the databasemap this map builder built.
	 *
	 * @return     the databasemap
	 */
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	/**
	 * The doBuild() method builds the DatabaseMap
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(JBulletinTransversalesPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(JBulletinTransversalesPeer::TABLE_NAME);
		$tMap->setPhpName('JBulletinTransversales');
		$tMap->setClassname('JBulletinTransversales');

		$tMap->setUseIdGenerator(false);

		$tMap->addForeignPrimaryKey('BULLETIN_ID', 'BulletinId', 'INTEGER' , 'bulletins', 'ID', true, 11);

		$tMap->addForeignPrimaryKey('COMPETENCE_ID', 'CompetenceId', 'INTEGER' , 'competences', 'ID', true, 11);

		$tMap->addColumn('RNE', 'Rne', 'VARCHAR', true, 10);

	} // doBuild()

} // JBulletinTransversalesMapBuilder
