<?php


/**
 * This class adds structure of 'd_discussion_membre' table to 'competencesrb' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    competencesrb.map
 */
class JDiscussionUtilisateursMapBuilder implements MapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'competencesrb.map.JDiscussionUtilisateursMapBuilder';

	/**
	 * The database map.
	 */
	private $dbMap;

	/**
	 * Tells us if this DatabaseMapBuilder is built so that we
	 * don't have to re-build it every time.
	 *
	 * @return     boolean true if this DatabaseMapBuilder is built, false otherwise.
	 */
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	/**
	 * Gets the databasemap this map builder built.
	 *
	 * @return     the databasemap
	 */
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	/**
	 * The doBuild() method builds the DatabaseMap
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(JDiscussionUtilisateursPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(JDiscussionUtilisateursPeer::TABLE_NAME);
		$tMap->setPhpName('JDiscussionUtilisateurs');
		$tMap->setClassname('JDiscussionUtilisateurs');

		$tMap->setUseIdGenerator(false);

		$tMap->addForeignPrimaryKey('DISCUSSION_ID', 'DiscussionId', 'INTEGER' , 'd_discussions', 'ID', true, 11);

		$tMap->addForeignPrimaryKey('UTILISATEUR_ID', 'UtilisateurId', 'INTEGER' , 'utilisateurs', 'ID', true, 11);

		$tMap->addColumn('CONNECTE', 'Connecte', 'CHAR', true, 1);

		$tMap->addColumn('CONNECTE_DATE', 'ConnecteDate', 'INTEGER', true, 11);

		$tMap->addColumn('REFUSE', 'Refuse', 'CHAR', true, 1);

	} // doBuild()

} // JDiscussionUtilisateursMapBuilder
