<?php


/**
 * This class adds structure of 'exe_doc_questions' table to 'competencesrb' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    competencesrb.map
 */
class JDocQuestionMapBuilder implements MapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'competencesrb.map.JDocQuestionMapBuilder';

	/**
	 * The database map.
	 */
	private $dbMap;

	/**
	 * Tells us if this DatabaseMapBuilder is built so that we
	 * don't have to re-build it every time.
	 *
	 * @return     boolean true if this DatabaseMapBuilder is built, false otherwise.
	 */
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	/**
	 * Gets the databasemap this map builder built.
	 *
	 * @return     the databasemap
	 */
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	/**
	 * The doBuild() method builds the DatabaseMap
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(JDocQuestionPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(JDocQuestionPeer::TABLE_NAME);
		$tMap->setPhpName('JDocQuestion');
		$tMap->setClassname('JDocQuestion');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, 11);

		$tMap->addForeignKey('EXE_DOC_ID', 'ExeDocId', 'INTEGER', 'exe_docs', 'ID', true, 11);

		$tMap->addColumn('QUESTION', 'Question', 'VARCHAR', true, 255);

		$tMap->addColumn('REPONSE', 'Reponse', 'BLOB', true, null);

		$tMap->addColumn('VOIR_REPONSE', 'VoirReponse', 'CHAR', true, 1);

		$tMap->addColumn('AIDE', 'Aide', 'VARCHAR', true, 255);

		$tMap->addColumn('AFFICHE_AIDE', 'AfficheAide', 'CHAR', true, 1);

		$tMap->addColumn('RNE', 'Rne', 'CHAR', true, 11);

		$tMap->addColumn('CREATED_ON', 'CreatedOn', 'INTEGER', true, 11);

	} // doBuild()

} // JDocQuestionMapBuilder
