<?php


/**
 * This class adds structure of 'logs' table to 'competencesrb' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    competencesrb.map
 */
class LogMapBuilder implements MapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'competencesrb.map.LogMapBuilder';

	/**
	 * The database map.
	 */
	private $dbMap;

	/**
	 * Tells us if this DatabaseMapBuilder is built so that we
	 * don't have to re-build it every time.
	 *
	 * @return     boolean true if this DatabaseMapBuilder is built, false otherwise.
	 */
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	/**
	 * Gets the databasemap this map builder built.
	 *
	 * @return     the databasemap
	 */
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	/**
	 * The doBuild() method builds the DatabaseMap
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(LogPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(LogPeer::TABLE_NAME);
		$tMap->setPhpName('Log');
		$tMap->setClassname('Log');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, 11);

		$tMap->addColumn('TYPE', 'Type', 'VARCHAR', true, 30);

		$tMap->addColumn('DEGRE', 'Degre', 'INTEGER', true, 3);

		$tMap->addColumn('TEXTE', 'Texte', 'VARCHAR', true, 255);

		$tMap->addColumn('DEBUT', 'Debut', 'INTEGER', true, 12);

		$tMap->addColumn('FIN', 'Fin', 'INTEGER', true, 12);

		$tMap->addColumn('IP', 'Ip', 'VARCHAR', true, 30);

		$tMap->addColumn('NAVIGATEUR', 'Navigateur', 'VARCHAR', true, 255);

		$tMap->addColumn('MARQUEUR', 'Marqueur', 'VARCHAR', true, 30);

		$tMap->addForeignKey('UTILISATEUR_ID', 'UtilisateurId', 'INTEGER', 'utilisateurs', 'ID', true, 11);

	} // doBuild()

} // LogMapBuilder
