<?php


/**
 * This class adds structure of 'utilisateurs' table to 'competencesrb' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    competencesrb.map
 */
class UtilisateurMapBuilder implements MapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'competencesrb.map.UtilisateurMapBuilder';

	/**
	 * The database map.
	 */
	private $dbMap;

	/**
	 * Tells us if this DatabaseMapBuilder is built so that we
	 * don't have to re-build it every time.
	 *
	 * @return     boolean true if this DatabaseMapBuilder is built, false otherwise.
	 */
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	/**
	 * Gets the databasemap this map builder built.
	 *
	 * @return     the databasemap
	 */
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	/**
	 * The doBuild() method builds the DatabaseMap
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(UtilisateurPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(UtilisateurPeer::TABLE_NAME);
		$tMap->setPhpName('Utilisateur');
		$tMap->setClassname('Utilisateur');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'INTEGER', true, 11);

		$tMap->addColumn('LOGIN', 'Login', 'VARCHAR', true, 50);

		$tMap->addForeignKey('RNE', 'Rne', 'VARCHAR', 'etablissements', 'RNE', true, 10);

		$tMap->addColumn('NOM', 'Nom', 'VARCHAR', true, 50);

		$tMap->addColumn('PRENOM', 'Prenom', 'VARCHAR', true, 50);

		$tMap->addColumn('CIVILITE', 'Civilite', 'VARCHAR', true, 5);

		$tMap->addColumn('NAISSANCE', 'Naissance', 'INTEGER', true, 12);

		$tMap->addColumn('PASSWORD', 'Password', 'VARCHAR', true, 100);

		$tMap->addColumn('EMAIL', 'Email', 'VARCHAR', true, 100);

		$tMap->addForeignKey('ROLE_ID', 'RoleId', 'INTEGER', 'roles', 'ID', true, 11);

		$tMap->addForeignKey('MATIERE_ID', 'MatiereId', 'INTEGER', 'matieres', 'ID', true, 11);

		$tMap->addForeignKey('CLASSE_ID', 'ClasseId', 'INTEGER', 'classes', 'ID', true, 11);

		$tMap->addColumn('SSO', 'Sso', 'CHAR', true, 1);

		$tMap->addValidator('LOGIN', 'unique', 'propel.validator.UniqueValidator', '', 'Ce login existe déjà.');

	} // doBuild()

} // UtilisateurMapBuilder
