<?php


/**
 * This class adds structure of 'etablissements' table to 'competencesrb' DatabaseMap object.
 *
 *
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive
 * (i.e. if it's a text column type).
 *
 * @package    competencesrb.map
 */
class etablissementMapBuilder implements MapBuilder {

	/**
	 * The (dot-path) name of this class
	 */
	const CLASS_NAME = 'competencesrb.map.etablissementMapBuilder';

	/**
	 * The database map.
	 */
	private $dbMap;

	/**
	 * Tells us if this DatabaseMapBuilder is built so that we
	 * don't have to re-build it every time.
	 *
	 * @return     boolean true if this DatabaseMapBuilder is built, false otherwise.
	 */
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	/**
	 * Gets the databasemap this map builder built.
	 *
	 * @return     the databasemap
	 */
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	/**
	 * The doBuild() method builds the DatabaseMap
	 *
	 * @return     void
	 * @throws     PropelException
	 */
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap(etablissementPeer::DATABASE_NAME);

		$tMap = $this->dbMap->addTable(etablissementPeer::TABLE_NAME);
		$tMap->setPhpName('etablissement');
		$tMap->setClassname('etablissement');

		$tMap->setUseIdGenerator(false);

		$tMap->addPrimaryKey('RNE', 'Rne', 'VARCHAR', true, 10);

		$tMap->addColumn('NOM', 'Nom', 'VARCHAR', true, 255);

		$tMap->addColumn('ADRESSE', 'Adresse', 'VARCHAR', true, 255);

		$tMap->addColumn('CODEPOSTAL', 'Codepostal', 'VARCHAR', true, 255);

		$tMap->addColumn('COMMUNE', 'Commune', 'VARCHAR', true, 255);

		$tMap->addValidator('RNE', 'unique', 'propel.validator.UniqueValidator', '', 'Cet établissement existe déjà.');

	} // doBuild()

} // etablissementMapBuilder
